package com.zksy.controller.property;

import cn.hutool.core.date.DateTime;
import com.zksy.property.domain.ARentalContract;
import com.zksy.property.service.ARentalContractService;
import com.zksy.utils.AjaxResult;
import com.zksy.utils.ExcelExportUtil;
import com.zksy.utils.ExcelImportUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.Arrays;

/**
 * @author Administrator
 * @version 1.0
 * @project enterprise-assets-service
 * @description 租赁合同管理控制层
 * @date 2025/6/24 14:33:13
 */
@RestController
@RequestMapping("/arentalContract")
@Api(tags = "租赁合同管理",description = "租赁合同管理desc")
public class ARentalContractController {
    @Autowired
    private ARentalContractService service;
    @GetMapping("/findByPage")
    @ApiOperation(value = "租赁合同管理查询分页")
    public AjaxResult findByPage(long pageNum, long pageSize, String tenantName,String contractNumber,String contractStatus){
        return AjaxResult.success(service.findByPage(pageNum, pageSize, tenantName,contractNumber,contractStatus));
    }
    @GetMapping("/getARentalContractList")
    @ApiOperation(value = "租赁合同管理查询")
    public AjaxResult getARentalContractList(String tenantName,String contractNumber,String contractStatus){
        return AjaxResult.success(service.getARentalContractList(tenantName,contractNumber,contractStatus));
    }
    @GetMapping("/getById/{id}")
    @ApiOperation(value = "根据Id查询租赁合同管理")
    public AjaxResult getById(@PathVariable String id){
        return AjaxResult.success(service.getById(id));
    }
    @PostMapping("/save")
    @ApiOperation(value = "租赁合同管理保存")
    public AjaxResult save(@RequestBody ARentalContract aassetManagement) {
        return service.save(aassetManagement) ? AjaxResult.success(aassetManagement) : AjaxResult.error("保存失败");
    }
    @PostMapping("/update")
    @ApiOperation(value = "租赁合同管理修改")
    public AjaxResult update(@RequestBody ARentalContract aassetManagement) {
        aassetManagement.setUpdateTime(LocalDateTime.now());
        return service.updateById(aassetManagement) ? AjaxResult.success(aassetManagement) : AjaxResult.error("修改失败");
    }
    @PostMapping("/deleteBatch")
    @ApiOperation(value = "租赁合同管理删除")
    public AjaxResult delete(@RequestBody String[] ids) {
        return service.removeBatchByIds(Arrays.asList(ids)) ? AjaxResult.success("删除成功") : AjaxResult.error("删除失败");
    }
    @PostMapping("/importData")
    @ApiOperation(value = "导入数据")
    public AjaxResult importData(MultipartFile file) {
        return AjaxResult.success(service.saveOrUpdateBatch(ExcelImportUtil.importExcel(file, ARentalContract.class)));
    }
    @GetMapping("/exportData")
    @ApiOperation(value = "导出数据")
    public void exportData(HttpServletResponse response,String tenantName,String contractNumber,String contractStatus) {
        ExcelExportUtil.exportExcel(response,service.getARentalContractList(tenantName,contractNumber,contractStatus), ARentalContract.class, "租赁合同管理","租赁合同管理");
    }

    @GetMapping("/generatorRental")
    @ApiOperation(value = "生成合同模版")
    public AjaxResult generatorRental(String id) {
        return null;
    }
}
